#include <cstdio>
#include <cstdlib>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "glut.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

static int width, height;   // XN[̕ƍ

#define FBOWIDTH  512       // t[obt@IuWFNg̕
#define FBOHEIGHT 512       // t[obt@IuWFNg̍

static GLuint fb;           // t[obt@IuWFNg
static GLuint cb;           // J[obt@p̃eNX`
static GLuint rb;           // fvXobt@p̃_[obt@

static GLuint sb;           // ʔˌ
static GLuint ab;           // ̔ˌ

/*
** VF[_IuWFNg
*/
#include "glsl.h"
static GLuint pass1, pass2;
static GLint diffuse, specular, ambient;

/*
** VF[_vO̓ǂݍ
*/
static GLuint loadShader(const char *vert, const char *frag)
{
  // VF[_IuWFNg̍쐬
  GLuint vertShader = glCreateShader(GL_VERTEX_SHADER);
  GLuint fragShader = glCreateShader(GL_FRAGMENT_SHADER);
  
  // VF[_̃\[XvO̓ǂݍ
  if (readShaderSource(vertShader, vert)) exit(1);
  if (readShaderSource(fragShader, frag)) exit(1);
  
  // VF[_vÕRpC^Nʂ𓾂ϐ
  GLint compiled, linked;

  // o[ebNXVF[_̃\[XvÕRpC
  glCompileShader(vertShader);
  glGetShaderiv(vertShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(vertShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in vertex shader.\n");
    exit(1);
  }
  
  // tOgVF[_̃\[XvÕRpC
  glCompileShader(fragShader);
  glGetShaderiv(fragShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(fragShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in fragment shader.\n");
    exit(1);
  }
  
  // vOIuWFNg̍쐬
  GLuint gl2Program = glCreateProgram();
  
  // VF[_IuWFNg̃VF[_vOւ̓o^
  glAttachShader(gl2Program, vertShader);
  glAttachShader(gl2Program, fragShader);
  
  // VF[_IuWFNg̍폜
  glDeleteShader(vertShader);
  glDeleteShader(fragShader);
  
  // VF[_vÕN
  glLinkProgram(gl2Program);
  glGetProgramiv(gl2Program, GL_LINK_STATUS, &linked);
  printProgramInfoLog(gl2Program);
  if (linked == GL_FALSE) {
    fprintf(stderr, "Link error.\n");
    exit(1);
  }

  return gl2Program;
}

/*
** 
*/
static void init(void)
{
#if defined(WIN32)
  // GLEW ̏
  GLenum err = glewInit();
  if (err != GLEW_OK) {
    fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
    exit(1);
  }
#endif

  // VF[_vO̍쐬
  pass1 = loadShader("pass1.vert", "pass1.frag");
  pass2 = loadShader("pass2.vert", "pass2.frag");

  // pass2 VF[_ uniform ϐ̏ꏊ𓾂
  diffuse = glGetUniformLocation(pass2, "diffuse");
  specular = glGetUniformLocation(pass2, "specular");
  ambient = glGetUniformLocation(pass2, "ambient");

  // J[obt@p̃eNX`pӂ
  glGenTextures(1, &cb);
  glBindTexture(GL_TEXTURE_2D, cb);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, FBOWIDTH, FBOHEIGHT, 0, GL_RGBA, GL_UNSIGNED_BYTE, 0);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);

  // ʔˌi[eNX`pӂ
  glGenTextures(1, &sb);
  glBindTexture(GL_TEXTURE_2D, sb);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, FBOWIDTH, FBOHEIGHT, 0, GL_RGBA, GL_UNSIGNED_BYTE, 0);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);

  // ̔ˌi[eNX`pӂ
  glGenTextures(1, &ab);
  glBindTexture(GL_TEXTURE_2D, ab);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, FBOWIDTH, FBOHEIGHT, 0, GL_RGBA, GL_UNSIGNED_BYTE, 0);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);

  // fvXobt@p̃_[obt@pӂ
  glGenRenderbuffersEXT(1, &rb);
  glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, rb);
  glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, FBOWIDTH, FBOHEIGHT);
  glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, 0);

  // t[obt@IuWFNg쐬
  glGenFramebuffersEXT(1, &fb);
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
  
  // t[obt@IuWFNgɃJ[obt@ƂăeNX`
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, cb, 0);
  
  // t[obt@IuWFNgɊgUˌ̊i[̃eNX`
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT1_EXT, GL_TEXTURE_2D, sb, 0);
  
  // t[obt@IuWFNgɊ̔ˌ̊i[̃eNX`
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT2_EXT, GL_TEXTURE_2D, ab, 0);
  
  // t[obt@IuWFNgɃfvXobt@Ƃă_[obt@
  glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, rb);
  
  // t[obt@IuWFNǧ
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

  // wiF
  glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

  // 
  glEnable(GL_LIGHT0);
}

/*
** _[^[Qbg̃Xg
*/
static const GLenum bufs[] = {
  GL_COLOR_ATTACHMENT0_EXT, //   J[obt@igUˌj
  GL_COLOR_ATTACHMENT1_EXT, //   ʔˌ
  GL_COLOR_ATTACHMENT2_EXT, //   ̔ˌ
};

/*
** ʕ\
*/
static void display(void)
{
  // ϊs̐ݒ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0, (GLdouble)width / (GLdouble)height, 1.0, 10.0);

  // fr[ϊs̐ݒ
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(3.0, 4.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  
  // r[|[g̐ݒ
  glViewport(0, 0, FBOWIDTH, FBOHEIGHT);

  // BʏLɂ
  glEnable(GL_DEPTH_TEST);

  // t[obt@IuWFNg
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

  // _[^[Qbgw肷
  glDrawBuffers(sizeof bufs / sizeof bufs[0], bufs);
  
  // pass1 VF[_Lɂ
  glUseProgram(pass1);
  
  // J[obt@ƃfvXobt@NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  // V[̕`
  glutSolidTeapot(1.0);
  glFlush();

  // _[^[Qbgɖ߂
  glDrawBuffer(GL_FRONT);
  
  // t[obt@IuWFNǧ
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

  // r[|[g̓EBhẼTCYɍ킹
  glViewport(0, 0, width, height);

  // Bʏ͍sȂ
  glDisable(GL_DEPTH_TEST);

  // eNX`}bsOLɂ
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, cb);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, sb);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, ab);

  // pass2 VF[_Lɂ
  glUseProgram(pass2);
  
  // uniform ϐɒl (eNX`jbgԍ) ݒ肷
  glUniform1i(diffuse, 0);
  glUniform1i(specular, 1);
  glUniform1i(ambient, 2);

  // ``
  glBegin(GL_TRIANGLE_FAN);
  glVertex2d(-1.0, -1.0);
  glVertex2d( 1.0, -1.0);
  glVertex2d( 1.0,  1.0);
  glVertex2d(-1.0,  1.0);
  glEnd();

  // VF[_𖳌ɂ
  glUseProgram(0);
  
  glFlush();
}

/*
** EBhETCY̕ύX
*/
static void resize(int w, int h)
{
  // EBhẼTCYۑ
  width = w;
  height = h;
}

/*
** L[{[h
*/
static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    // ESC  q  Q ^CvI
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH);
  glutCreateWindow("FBO Sample");
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
